package com.perforce.maven.scm.provider.p4.command.checkout;

/*
 * Copyright (c) 2010 Perforce Software. All rights reserved.
 */

import org.apache.maven.scm.ScmFileSet;
import org.apache.maven.scm.command.checkout.CheckOutScmResult;
import org.apache.maven.scm.tck.command.checkout.CheckOutCommandTckTest;
import org.codehaus.plexus.util.FileUtils;

import com.perforce.maven.scm.provider.p4.P4ScmTestUtils;

public class P4CheckOutCommandTckTest
    extends CheckOutCommandTckTest
{

    /** {@inheritDoc} */
    public String getScmUrl()
        throws Exception
    {
        return P4ScmTestUtils.getScmUrl();
    }

    /** {@inheritDoc} */
    public void initRepo()
        throws Exception
    {
        P4ScmTestUtils.initRepo();
        resetToOrignalFiles();
    }

    private void resetToOrignalFiles()
        throws Exception
    {
        checkOut( getWorkingCopy(), getScmRepository() );
        ScmFileSet fileSet = new ScmFileSet( getWorkingCopy(), P4ScmTestUtils.getAddedIncludes(), null );
        getScmManager().getProviderByUrl( getScmUrl() ).remove( getScmRepository(), fileSet,
                                                                "Remove previous test files" );
        fileSet = new ScmFileSet( getWorkingDirectory(), P4ScmTestUtils.getTestIncludes(), null );
        getScmManager().getProviderByUrl( getScmUrl() ).edit( getScmRepository(), fileSet );
        P4ScmTestUtils.populateOriginalData( getBasedir(), getWorkingCopy() );
        checkIn( getWorkingCopy(), getScmRepository() );
        FileUtils.deleteDirectory( getWorkingDirectory() );

    }

    public void testSecondCheckoutUsingTheSameSpec()
        throws Exception
    {
        CheckOutScmResult result = checkOut( getWorkingCopy(), getScmRepository() );
        //fix me check for file count
    }
}
